/*
 * what.c
 * provide "what"-command for systems lacking it
 * you can do what you want with this.
 * written by Oliver Schroeder
 *
 */

#include <stdio.h>
#include <string.h>
#include <ctype.h>

int StopAtFirstHit = 0;

int grep ( const char* filename )
{
	FILE*	in;
	int	match = 0;
	int	c;

	in = fopen (filename, "r");
	if (in == 0)
		{
		printf ("could not open '%s'\n", filename);
		return (1);
		}
	printf ("%s:\n", filename);
	while ((c = fgetc (in)) != EOF)
		{
		switch (match)
			{
			case 0:
				if (c == '@')
					match++;
				break;
			case 1:
				if (c == '(')
					match++;
				else	match = 0;
				break;
			case 2:
				if (c == '#')
					match++;
				else	match = 0;
				break;
			case 3:
				if (c == ')')
					match++;
				else
					match = 0;
				break;
			case 4:
				printf ("\t");
				match++;
			case 5:
				if ((c == '\0') || (c == '\n')
				|| (c == '"') || (c == '>') || (c == '\\'))
					{
					printf ("\n");
					match = 0;
					if (StopAtFirstHit == 1)
						{
						StopAtFirstHit = 2;
						return (0);
						}
					}
				else	{
					printf ("%c", c);
					}
				break;
			}
		}
	fclose (in);
}

int main ( int argc, char* argv [] )
{
	int	I;

	if (argc < 2)
		{
		printf ("syntax: %s [-s] file [file...]\n", argv [0]);
		return (0);
		}
	for (I = 1; I < argc; I++)
		{
		if (argv [I][0] == '-')
			{
			if (strcmp ("-s", argv [I]) == 0)
				{
				printf ("-s\n");
				StopAtFirstHit = 1;
				}
			else	{
				printf ("illegal option: %s\n", argv[I]);
				return (1);
				}
			}
		else	{
			if (grep (argv [I]) != 0)
				return (0);
			if (StopAtFirstHit > 1)
				return (0);
			}
		}
	return (0);
}
